jQuery(function($){

    var NUM_COLS = 5;
    var lives = 10;

    var ticks = 0;
    var score = 0;

    var fruits = [];
    for (i=0; i<4; i++){
        fruits[i] = new Image();
        fruits[i].src = "gy"+(i+1)+".png";
    }

    var gameArea = $('#gamearea');
    gameArea.width($(window).width());
    gameArea.height($(window).height());
    var stepWidth = gameArea.width() / NUM_COLS;

    var bowl = $('<img src="bowl.png">');
    bowl.appendTo(gameArea)
        .css({
            position: 'absolute',
            bottom: '0px',
            width: stepWidth
        });

   $('body').on('mousemove', function(e){
        var p = gameArea.offset();
        var x = e.pageX - p.left;
        if (x<stepWidth/2 || x>gameArea.width()-stepWidth/2) {
           return;
        }
        bowl.css({
            left: Math.round((x - stepWidth / 2) / stepWidth)  * stepWidth
        })
    });

    function makeRandomFruitBg(divImage){
        var i = Math.floor(Math.random()*fruits.length);
        divImage.css({
            width: stepWidth,
            height: stepWidth,
            'background-size': stepWidth,
            'background-image': "url("+fruits[i].src+")"
        });
    }


    function makeFruit(){
        var pos = Math.floor(Math.random()*NUM_COLS);
        var wrapperDiv = $('<div>');
        wrapperDiv.addClass('fruit');
        wrapperDiv.css({
            width: stepWidth,
            height: stepWidth,
            left: stepWidth * pos + "px"
        });
        var divImage = $('<div>');
        divImage.addClass('imageholder');
        makeRandomFruitBg(divImage);
        divImage.appendTo(wrapperDiv);
        wrapperDiv.appendTo(gameArea);
        var animTime = 5000 - score*100;
        if (animTime < 1000) {
            animTime = 1000;
        }
        wrapperDiv.animate({
            top: gameArea.height() - wrapperDiv.height()/2
        }, animTime, function(){
            $(this).remove();
            if (lives>0){
                lives--;
                $('#lives span').text(lives);
            }
        });
    }



    function timer(){
        if (lives == 0){
            gameArea.find('.fruit').remove();
            return;
        }
        if (ticks % Math.max(3, 25-Math.floor(score/3)) == 0){
            makeFruit();
        }
        ticks++;
        gameArea.find('.fruit').each(function(){
            var tPos = $(this).position();
            var bPos = bowl.position();
            var dx = (tPos.left + $(this).width()/2) - (bPos.left + bowl.width()/2);
            var dy = (tPos.top + $(this).height()/2) - (bPos.top + bowl.height()/2);
            if (dy>0) {
                $(this).addClass('missed');
            }
            if (dy < 0 && dy > -stepWidth/2 && dx < stepWidth / 2 && dx > -stepWidth/2) {
                score++;
                $(this).stop().remove();
                $('#score span').text(score);
            }
        });
    }

    $('#lives span').text(lives);
    $('#score span').text(score);
    setInterval(timer, 50);
});
